#include<stdio.h>
#include<stdlib.h>

#define eps 1e-10
#define max_points 1000000

double x,y,z,xmin,dx,xmax,ymin,dy,ymax,zmin,dz,zmax;
long i;
char *filename;
FILE *f;

int main(int argc, char* argv[]) {
  if (argc!=11) fprintf(stderr,"Error!!! Wrong number of arguments.\n"),exit(1);
  xmin=atof(argv[1]);
  dx  =atof(argv[2]);
  xmax=atof(argv[3]);
  ymin=atof(argv[4]);
  dy  =atof(argv[5]);
  ymax=atof(argv[6]);
  zmin=atof(argv[7]);
  dz  =atof(argv[8]);
  zmax=atof(argv[9]);
  filename=argv[10];
  i=0;
  f=fopen(filename,"w");
  for (x=xmin; x<xmax+eps; x+=dx)
    for (y=ymin; y<ymax+eps; y+=dy)
      for (z=zmin; z<zmax+eps; z+=dz) {
	  fprintf(f,"%7.3lf   %7.3lf   %7.3lf  \n",x,y,z);
          i++;
          if (i>=max_points) {
            fprintf(stderr,"make_grid3d: warning: %ld lines are written to file %s. Program stopped.\n",i,filename);
            fclose(f);
            exit(0);
          }
      }
  fclose(f);
  return 0;
}

